      SUBROUTINE AST3D(A,M,N,B,IERR)
C*********************************************************C
C   PEEHE CCTEM A*X=B C OOTEHO OPEEEHHO     C
C       CMMETPHO TPEXAOHAHO MATPE A.         C
C*********************************************************C
         INTEGER IERR,M,N
         DOUBLE PRECISION A,B
         DIMENSION A(M,2),B(1)
C
C  YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH
         EXTERNAL UTAFSI
         INTEGER        K,KB,KF,KP1,NMD2
         DOUBLE PRECISION T,T1,X
       X = 0.0D0
   10  CONTINUE
C
C  POBEPKA PABHOCT AAH APAMETPOB M  N
       IF (N .GE. 1 .AND. M .GE. 1) GO TO 20
          IERR = 65
          CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
          GO TO 260
   20  CONTINUE
       IERR = 0
C
C  POBEPKA HA CYA 1*1
       IF (N .GT. 1) GO TO 50
          IF (A(1,2) .NE. 0.0D0) GO TO 40
             IERR = -1
             IF (B(1) .NE. 0.0D0) GO TO 30
                B(1) = 1.0D0
                GO TO 250
   30     CONTINUE
          IERR = 67
          CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
          GO TO 260
   40  CONTINUE
       B(1) = B(1)/A(1,2)
       GO TO 260
C
C  PBEEHE MATP K CEAHOMY BY
   50  CONTINUE
       NMD2 = (N - 1)/2
       IF (N .EQ. 2) GO TO 90
          KB = N - 1
          DO 80 K = 1, NMD2
             KF = K + 1
             IF (A(K,2) .NE. 0.0D0) GO TO 60
                IERR = -K
                CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
                GO TO 260
   60     CONTINUE
          T = A(KF,1)/A(K,2)
          A(KF,2) = A(KF,2) - T*A(KF,1)
          B(KF) = B(KF) - T*B(K)
          KF = KB + 1
          IF (A(KF,2) .NE. 0.0D0) GO TO 70
             IERR = -KF
             CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
             GO TO 260
   70     CONTINUE
          T1 = A(KF,1)/A(KF,2)
          A(KB,2) = A(KB,2) - T1*A(KF,1)
          B(KB) = B(KB) - T1*B(KF)
          KB = KB - 1
   80  CONTINUE
   90  CONTINUE
       KP1 = NMD2 + 1
       KB = MOD(N,2)
       IF (KB .NE. 0) GO TO 110
          IF (A(KP1,2) .NE. 0.0D0) GO TO 100
             IERR = -KP1
             CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
             GO TO 260
  100  CONTINUE
       T = A(KP1+1,1)/A(KP1,2)
       A(KP1+1,2) = A(KP1+1,2) - T*A(KP1+1,1)
       B(KP1+1) = B(KP1+1) - T*B(KP1)
       KP1 = KP1 + 1
  110  CONTINUE
C
C  PEEHE CCTEM
       IF (A(KP1,2) .NE. 0.0D0) GO TO 130
          IERR = -KP1
          IF (B(KP1) .NE. 0.0D0) GO TO 120
             B(KP1) = 1.0D0
             GO TO 140
  120  CONTINUE
       IERR = 67
       CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
       GO TO 260
  130  CONTINUE
       B(KP1) = B(KP1)/A(KP1,2)
  140  CONTINUE
       IF (N .EQ. 2) GO TO 220
          K = KP1 - 1
          KB = KP1 + NMD2 - 1
          DO 210 KF = KP1, KB
             T = B(K) - A(K+1,1)*B(K+1)
             IF (A(K,2) .NE. 0.0D0) GO TO 160
                IERR = -K
                IF (T .NE. 0.0D0) GO TO 150
                   B(K) = 1.0D0
                   GO TO 170
  150        CONTINUE
             IERR = 67
             CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
             GO TO 260
  160     CONTINUE
          B(K) = T/A(K,2)
  170     CONTINUE
          T = B(KF+1) - A(KF+1,1)*B(KF)
          IF (A(KF+1,2) .NE. 0.0D0) GO TO 190
             IERR = -KF - 1
             IF (T .NE. 0.0D0) GO TO 180
                B(KF+1) = 1.0D0
                GO TO 200
  180     CONTINUE
          IERR = 67
          CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
          GO TO 260
  190     CONTINUE
          B(KF+1) = T/A(KF+1,2)
  200     CONTINUE
          K = K - 1
  210  CONTINUE
  220  CONTINUE
       KB = MOD(N,2)
       IF (KB .NE. 0) GO TO 250
          T = B(1) - A(2,1)*B(2)
          IF (A(1,2) .NE. 0.0D0) GO TO 240
             IERR = -1
             IF (T .NE. 0.0D0) GO TO 230
                B(1) = 1.0D0
                GO TO 250
  230     CONTINUE
          IERR = 67
          CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
          GO TO 260
  240  CONTINUE
       B(1) = T/A(1,2)
  250  CONTINUE
       IF (IERR .NE. 0) CALL UTAFSI(1HA,1HS,1HT,1H3,1HD,IERR)
  260  CONTINUE
       RETURN
      END
